#ifndef PICOLED_ST7889_H
#define PICOLED_ST7889_H

#include <hardware/spi.h>

#include "picoled.h"

namespace picoled
{

class st7789 : public oled
{
public:
  st7789(size_t width, size_t height, spi_inst_t* spi, uint8_t cs_pin, uint8_t dc_pin);
  virtual ~st7789() = default;

  void write(int x, int y, const pixel& p) override
  {
    oled::write(x, y, format(p));
  }

protected:
  void update_impl() const override;

private:
  void command(uint8_t cmd) const;
  void command(uint8_t cmd, uint8_t param) const;
  void command(uint8_t cmd, const uint8_t* params, size_t param_count) const;

  spi_inst_t* spi;
  uint8_t cs_pin;
  uint8_t dc_pin;
  uint8_t dma_tx;

  static pixel format(const pixel& p);

  static void dma_handler();
  static int cs_pins[12];
};

}

#endif//PICOLED_ST7889_H
